#include <stdio.h>
#include <math.h>

#include "h11c.h"

//**************************************************************************************
//get_area_infoĂяoB
//ϐ̏s
//**************************************************************************************
void get_area_info_init(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX])
{
int		i;

	for(i = 0; i < image_info->area_num; i++)
	{
		area_info[i].pix_num = 0;
		area_info[i].cog_x = 0;
		area_info[i].cog_y = 0;

		area_info[i].box[0][0] = 319;
		area_info[i].box[0][1] = 239;

		area_info[i].box[1][0] = 0;
		area_info[i].box[1][1] = 0;
	}
}
//**************************************************************************************
//get_area_infoĂяoB
//eGÃsNZJEg
//**************************************************************************************
int get_area_info_areanum(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H])
{
int		i, x, y, object_area_num;

	for(y = image_info->start_y + 1; y <= image_info->end_y - 1; y++)
	{
		for(x = 1; x < IMG_SIZE_H - 1; x++)
		{
			if(image_att[0][y][x] == 0)//255̏ꏊ͔Ƃ(wiGA)
			{
				area_info[image_att[1][y][x]].pix_num++;
			}
		}
	}

	object_area_num = 0;
	for(i = 0; i < image_info->area_num; i++)
	{
		if(area_info[i].pix_num != 0) object_area_num++;
	}

	return(object_area_num);
}

//**************************************************************************************
//get_area_infoĂяoB
//eGÃsNZJEg
//**************************************************************************************
void get_area_info_cog(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H])
{
int		i, x, y;
int		pix_num_work[1024];


	//̈̏dSixjZo
	for(i = 0; i < image_info->area_num; i++) pix_num_work[i] = 0;
	for(y = image_info->start_y + 1; y <= image_info->end_y - 1; y++)
	{
		for(x = 1; x < 319; x++)
		{
			if(image_att[1][y][x] != -1)
			{
				if(pix_num_work[ image_att[1][y][x] ] < area_info[image_att[1][y][x]].pix_num / 2)
				{
					pix_num_work[ image_att[1][y][x] ]++;
					area_info[image_att[1][y][x]].cog_y = y;
				}
			}
		}
	}

	//̈̏dSiwjZo
	for(i = 0; i < image_info->area_num; i++) pix_num_work[i] = 0;
	for(x = 1; x < 319; x++)
	{
		for(y = image_info->start_y + 1; y <= image_info->end_y - 1; y++)
		{
			if(image_att[1][y][x] != -1)
			{
				if(pix_num_work[ image_att[1][y][x] ] < area_info[image_att[1][y][x]].pix_num / 2)
				{
					pix_num_work[ image_att[1][y][x] ]++;
					area_info[image_att[1][y][x]].cog_x = x;
				}
			}
		}
	}
}
//**************************************************************************************
//get_area_infoĂяoB
//anwvZ
//**************************************************************************************
void get_area_info_box(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H])
{
int		x, y;


	//anw̎o
	for(y = image_info->start_y + 1; y <= image_info->end_y - 1; y++)
	{
		for(x = 1; x < 319; x++)
		{
			if(image_att[1][y][x] != -1)
			{
				//XN[W_蒸_
				if(x <= area_info[ image_att[1][y][x] ].box[0][0])
				{
					area_info[ image_att[1][y][x] ].box[0][0] = x;

					area_info[ image_att[1][y][x] ].coo_max[0][0] = x;
					area_info[ image_att[1][y][x] ].coo_max[0][1] = y;
				}
				//XN[W_蒸_
				if(y <= area_info[ image_att[1][y][x] ].box[0][1])
				{
					area_info[ image_att[1][y][x] ].box[0][1] = y;

					area_info[ image_att[1][y][x] ].coo_max[1][0] = x;
					area_info[ image_att[1][y][x] ].coo_max[1][1] = y;
				}

				//XN[W_牓蒸_
				if(x >= area_info[ image_att[1][y][x] ].box[1][0])
				{
					area_info[ image_att[1][y][x] ].box[1][0] = x;

					area_info[ image_att[1][y][x] ].coo_max[2][0] = x;
					area_info[ image_att[1][y][x] ].coo_max[2][1] = y;
				}
				//XN[W_牓蒸_
				if(y >= area_info[ image_att[1][y][x] ].box[1][1])
				{
					area_info[ image_att[1][y][x] ].box[1][1] = y;

					area_info[ image_att[1][y][x] ].coo_max[3][0] = x;
					area_info[ image_att[1][y][x] ].coo_max[3][1] = y;
				}
			}
		}
	}
}

//**************************************************************************************
//get_area_infoĂяoB
//anwvZ
//**************************************************************************************
void get_area_info_center(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H])
{
int		i, j, k, l;
int		dist_info[6][2];

double	a, b, dist[6];


	for(l = 0; l < image_info->area_num; l++)
	{
		if(area_info[l].pix_num != 0)
		{
			k = 0;
			for(i = 0; i < 3; i++)
			{
				for(j = i + 1; j < 4; j++)
				{
					a = area_info[l].coo_max[i][0] - area_info[l].coo_max[j][0];
					b = area_info[l].coo_max[i][1] - area_info[l].coo_max[j][1];
					a = a * a;
					b = b * b;

					dist[k] = sqrt(a + b);
					/*
					if((j - i) != 1) dist[k] = sqrt(a + b);
					else dist[k] = 255.0;//ׂ̓_͏
					*/

					dist_info[k][0] = i;
					dist_info[k][1] = j;
					k++;
				}
			}

			//ԒΊpI
			a = dist[0];//Œ
			j = 0;
			for(i = 0; i < 6; i++)
			{
				if(dist[i] > a)
				{
					//Œ̃Zbg
					a = dist[i];
					j = i;
				}
			}

			//S̎n_AI_vZ
			area_info[l].centerline[0][0] = 
					area_info[l].coo_max[ dist_info[j][0] ][0];

			area_info[l].centerline[0][1] = 
					area_info[l].coo_max[ dist_info[j][0] ][1];


			area_info[l].centerline[1][0] = 
					area_info[l].coo_max[ dist_info[j][1] ][0];

			area_info[l].centerline[1][1] = 
					area_info[l].coo_max[ dist_info[j][1] ][1];
		}
	}
}
//**************************************************************************************
//**************************************************************************************
void get_area_info(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H])
{
int		i, object_area_num;

	//********************************************************************************
	//̗̈̃sNZ
	get_area_info_init(image_info, area_info);

	//sNZWv
	object_area_num = get_area_info_areanum(image_info, area_info, image_att);

	//̈̏dSZo
	get_area_info_cog(image_info, area_info, image_att);

	//anw̎o
	get_area_info_box(image_info, area_info, image_att);

	//̈̒SvZ
	get_area_info_center(image_info, area_info, image_att);

	//eXgo
	//area_info\̂̔z̓AۂɎgWv
	printf("\n get_area_info\n");
	for(i = 0; i < image_info->area_num; i++)
	{
		printf("%4d : ʐ = %6d  --- ", i, area_info[i].pix_num);
		printf("dS X = %4d , Y = %4d\n", area_info[i].cog_x, area_info[i].cog_y);
	}
	printf("ΏۃGA: %4d\n", object_area_num);
}

//**********************************************************
//**********************************************************
// xtIĂC[WAȏ̖ʐς݂̂̂QlC[WƂĕԂB
//**********************************************************
void get_large_area(struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H], unsigned char image[IMG_SIZE_V][IMG_SIZE_H], int pix_num)
{
int		x, y;
char	work_c;

	for(y = 0; y < IMG_SIZE_V; y++)
    {
	   for(x = 0; x < IMG_SIZE_H; x++)
	   {
		   if(area_info[ image_att[1][y][x] ].pix_num > pix_num)
		   {
			   image[y][x] = 255;
		   }
		   else
		   {
			   image[y][x] = 0;
		   }
	   }
   }
}

