#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "h11c.h"

void decide_area_shape(struct IMAGE_INFO *image_info
					   , struct AREA_INFO area_info[AREANUM_MAX]
					   , int image_att[2][IMG_SIZE_V][IMG_SIZE_H])
{
int		i, x, y, xi, yi, data_num, box_i[2][2];
int		length_i, height_i, width_info[IMG_SIZE_H], work_cog[2];
unsigned char	image_work[IMG_SIZE_V][IMG_SIZE_H];

double	a, dx, dy, shape_data[WAVE_MAX][2];
double	box_d[2][2];

Calc_2D		calc_2D;

	printf("\n decide_area_shape \n");
	for(i = 0; i < image_info->area_num; i++)
	{
		if(area_info[i].pix_num < WAVE_MAX - 1)
		{
			//[Nϐ
			for(y = 0; y < IMG_SIZE_V; y++)
				for(x = 0; x < IMG_SIZE_H; x++) image_work[y][x] = 255;

			//vZ
			dx = (double)(area_info[i].centerline[1][0] - area_info[i].centerline[0][0]);
			dy = (double)(area_info[i].centerline[1][1] - area_info[i].centerline[0][1]);
			area_info[i].dir = atan2(dy, dx);

			//********************************************************************
			//C[W̍\vf̍Wo
			data_num = 0;
			for(yi = area_info[i].box[0][1]; yi <= area_info[i].box[1][1]; yi++)
			{
				for(xi = area_info[i].box[0][0]; xi <= area_info[i].box[1][0]; xi++)
				{
					if(image_att[1][yi][xi] == area_info[i].ID)
					{
						shape_data[data_num][0] = xi;
						shape_data[data_num][1] = yi;
						data_num++;

						//Ώۃf[^̏ς񂾂烋[vI
						if(data_num >= area_info[i].pix_num || data_num > WAVE_MAX)
						{
							xi = IMG_SIZE_H;
							yi = IMG_SIZE_V;
						}
					}
				}
			}

			//********************************************************************
			//̈撷߂邽߁Ä̒wɕsƂȂlɉ]
			calc_2D.rotate_1D(shape_data, (double)area_info[i].cog_x
				, (double)area_info[i].cog_y, -area_info[i].dir, area_info[i].pix_num);

			//]̗̈̂anwo
			box_d[0][0] = IMG_SIZE_H;
			box_d[0][1] = IMG_SIZE_V;
			box_d[1][0] = 0;
			box_d[1][1] = 0;

			for(data_num = 0; data_num < area_info[i].pix_num; data_num++)
			{
				if(shape_data[data_num][0] < box_d[0][0]) box_d[0][0] = shape_data[data_num][0];
				if(shape_data[data_num][1] < box_d[0][1]) box_d[0][1] = shape_data[data_num][1];

				if(shape_data[data_num][0] > box_d[1][0]) box_d[1][0] = shape_data[data_num][0];
				if(shape_data[data_num][1] > box_d[1][1]) box_d[1][1] = shape_data[data_num][1];
			}

			area_info[i].length = box_d[1][0] - box_d[0][0];
			area_info[i].height = box_d[1][1] - box_d[0][1];

			//ʐςPsNZȂꍇ̃f[^̗O
			if(area_info[i].height < 1.0) area_info[i].height = 1.0;
			area_info[i].proportion_l_h = area_info[i].length / area_info[i].height;

			//[NC[WGAɓlɕsړ
			//ړ̊_͂anw̍
			calc_2D.palla_conv(shape_data, box_d, area_info[i].pix_num, -1.0);
			//********************************************************************
			//[NC[W쐬
			box_i[0][0] = IMG_SIZE_H;
			box_i[0][1] = IMG_SIZE_V;
			box_i[1][0] =   0;
			box_i[1][1] =   0;
			for(data_num = 0; data_num < area_info[i].pix_num; data_num++)
			{
				x = (int)shape_data[data_num][0];
				y = (int)shape_data[data_num][1];
				image_work[y][x] = 0;

				if(x < box_i[0][0]) box_i[0][0] = x;
				if(y < box_i[0][1]) box_i[0][1] = y;

				if(x > box_i[1][0]) box_i[1][0] = x;
				if(y > box_i[1][1]) box_i[1][1] = y;
			}

			length_i = box_i[1][0] - box_i[0][0];
			height_i = box_i[1][1] - box_i[0][1];
			//********************************************************************
			//}`̓o
			if(area_info[i].length == 0.0) area_info[i].length = 1.0;
			area_info[i].line_W = area_info[i].pix_num / (int)area_info[i].length;

			area_info[i].fill_rate = (double)area_info[i].pix_num / (area_info[i].length * area_info[i].height);

			//C(}`)̕ϑEEEɃXLČvZ
			for(x = 0; x < IMG_SIZE_H; x++) width_info[x] = 0;

			for(x = 0; x <= box_i[1][0]; x++)
			{
				for(y = 0; y <= box_i[1][1]; y++)
				{
					if(image_work[y][x] == 0) width_info[x] = width_info[x] + 1;
				}
			}
			//ő߂
			area_info[i].max_width = 0;
			for(x = 0; x <= length_i; x++)
			{
				if(area_info[i].max_width < width_info[x]) area_info[i].max_width = width_info[x];
			}

			//}`̔f
			work_cog[0] = area_info[i].cog_x - (int)box_d[0][0];
			work_cog[1] = area_info[i].cog_y - (int)box_d[0][1];
			decide_area_shape1(&area_info[i], image_work, box_i, work_cog);
		
			//eXgo
			a = area_info[i].dir / 3.14159 * 180.0;
			printf("%4d :  = %6.1fF@c = %6.1fF@̑ = %4d: ` = %d\n", i, a, area_info[i].proportion_l_h, area_info[i].line_W, area_info[i].shape_code);
		}
		else
		{
			printf("xFzg؂܂B`󔻒fsmł(decide_area_shape)\n");
			area_info[i].cog_x = IMG_SIZE_H;
			area_info[i].cog_y = IMG_SIZE_V;
			area_info[i].proportion_l_h = 1.0;
			area_info[i].line_W = 1.0;
			area_info[i].shape_code = -1;
			area_info[i].dir = 0.0;
			a = 0.0;
			printf("%4d :  = %6.1fF@c = %6.1fF@̑ = %4d: ` = %d\n", i, a, area_info[i].proportion_l_h, area_info[i].line_W, area_info[i].shape_code);
		}
	}
}

/*FłGA𖾂邳̈ႤO[ɂ*/
void change_image_color(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX],
				   unsigned char image[3][IMG_SIZE_V][IMG_SIZE_H], int image_att[2][IMG_SIZE_V][IMG_SIZE_H])
{
int		i, j, xi, yi, data_num;


	for(i = 0; i < image_info->area_num; i++)
	{
		if(area_info[i].shape_code != -1)
		{
			//********************************************************************
			data_num = 0;
			for(yi = area_info[i].box[0][1]; yi <= area_info[i].box[1][1]; yi++)
			{
				for(xi = area_info[i].box[0][0]; xi <= area_info[i].box[1][0]; xi++)
				{
					if(image_att[1][yi][xi] == area_info[i].ID)
					{
						if(area_info[i].shape_code == 1) for(j = 0; j < 3; j++) image[j][yi][xi] = 0;
						if(area_info[i].shape_code == 2) for(j = 0; j < 3; j++) image[j][yi][xi] = 160;
						if(area_info[i].shape_code == 3) for(j = 0; j < 3; j++) image[j][yi][xi] = 90;
						if(area_info[i].shape_code == 4) for(j = 0; j < 3; j++) image[j][yi][xi] = 200;
						data_num++;

						if(data_num >= area_info[i].pix_num)
						{
							xi = IMG_SIZE_H;
							yi = IMG_SIZE_V;
						}
					}
				}
			}
		}

	}
}