#define  WAVE_MAX		16384
#define  WAVE_MAX2		1000
#define  AREANUM_MAX	256
#define  MAPDB_MAX		16
#define  OBSTDB_MAX		256

#define  PI 3.141592654
#define  com 1

#define	CAPT_IMG_L		"C:\\Msdevstd\\work\\h11c_left.bmp"			//Lv`IWiC[Wiځj
#define	CAPT_IMG_R		"C:\\Msdevstd\\work\\h11c_right.bmp"		//Lv`IWiC[WiEځj
#define	CAPT_IMG_L_bin	"C:\\Msdevstd\\work\\h11c_left_bin.bmp"		//Lv`QlσC[Wiځj
#define	CAPT_IMG_R_bin	"C:\\Msdevstd\\work\\h11c_right_bin.bmp"	//Lv`QlσC[WiEځj
#define	WORK_IMG		"C:\\Msdevstd\\work\\h11c_work.bmp"			//eXgłƎgo̓C[WȂǗp

#define	REQ_FILE		"C:\\Msdevstd\\work\\req_file.dat"			//ʂ̃vZX̃Lv`NGXgt@C
#define	notify_file		"C:\\Msdevstd\\work\\notify.txt"			//Lv`uãvZXɒm点t@C
#define	report_file		"C:\\Msdevstd\\work\\report.txt"			//XeIvʂuãvZXɓn߃t@C

#define IMG_SIZE_H		320		//J痈摜̉sNZ
#define IMG_SIZE_V		240		//J痈摜̏csNZ

//wb_CN[h(OpenCV֘A)
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

//Cuǂݍ(OpenCV֘A)
#pragma comment(lib,"cv.lib")
#pragma comment(lib,"cxcore.lib")
#pragma comment(lib,"highgui.lib")

//wb_CN[h(videoInput Library֘A)
#include <videoInput.h>
// Cuǂݍ(videoInput Library֘A)
#pragma comment(lib,"videoInput.lib")

//摜Fp[^\
struct RECOG_PLM
{
	int		max_pixnum;			//Ql̃CfbNXtɗLƂPGA̍ősNZ
	int		min_pixnum;			//@ŏsNZ
	int		left_cam_id;		//Ĵhcitraڑ̏ԂŕςlȂ̂ŕύX\ƂP^Oj

	float	obj_RGB[2][16][3];	//FΏۂ̐FxNgW
	int		obj_RGB_num[2];		//FΏۂ̐FxNg̐

	float	color_th;			//FłQlƂ̃XbVh
	float	min_dist;			//XeI}b`O莞̍ŏ
	float	max_dist;			//XeI}b`O莞̍ő勗
};

struct IMAGE_INFO
{
	int		start_x, end_x;	//t[͈̏
	int		start_y, end_y;	//t[͈̏
	int		level[4];
					// level[0]: 
					// level[1]: Œ
					// level[2]: ō
					// level[3]: Ql臒l
	int		area_num;
};

//CfbNXt^ς݃GȂ
struct AREA_INFO
{
	int		cog_x, cog_y;		//}`ƂĂ̏dSW
	int		pix_num;			//sNZ
	int		shape_code;			//`R[h
	int		line_W;				//`ƌꍇ̐iCg[XpɏɈĂz肵Ăj
	int		max_width;			//ő啝H
	int		box[2][2];			//{bNXiQcOtBbNẌʓIȈӖł́j
	//box[0][0]: {bNX̍wWA@box[0][1]: {bNX̍xW
	//box[1][0]: {bNX̉EwWA@box[0][1]: {bNX̉ExW
	int		coo_max[4][2];		//{bNẌԔяoĂꏊ̍W
	int		centerline[2][2];	//{bNXňԗĂꏊȂiCg[Xpj
	int		ID;					//GAID
	int		color;
	int		work;
	float	dir;
	float	length;
	float	height;
	float	proportion_l_h;
	float	fill_rate;
};

/*Q􉽌vZTu[`Q*/
/* 6legs_2dcalc.c ***********/
class Calc_2D
{
public:
	void find_tan_lines(double coo0[2][2], double coo1[8][2], double R);
	double var_point(double coo[3][2]);
	double var_point2(double coo[2][2], double coo_C[2], double coo_D[2]);
	int crcir(double coo[2][2],double r[2]);
	void tan_point(double coo[2][2],double R);
	double dist_2points(double coo[2][2]);
	void mid_2points(double coo[2][2]);
	void rotate_1D(double coo[WAVE_MAX][2], double center_x,
				double center_y, double direction, int data_num);
	double vector_dir_f(double coo[3][2]);
	double vector_rot_f(double coo[3][2], int rot_dir);
	void coodinate_copy(double coo0[WAVE_MAX][2], double coo1[WAVE_MAX][2], int max_num);
	void palla_conv(double coo0[WAVE_MAX][2], double diff[1][2], int max_num, double dir);
	double arc_length(double R, double angle);
	double vector_intpoint(double	coo_line[2][2][2], double coo_tanpoint[2]);
};



/*file_IO_routines.cpp********/
int devide_into_field(char line[1024], char delimiter[16], char fields[32][64]);

//**************************************************************************
//vision2.cpp
double get_av_local1(int center_x, int center_y, int area_width, struct IMAGE_INFO *image_info, unsigned char image_mono[IMG_SIZE_V][IMG_SIZE_H]);
void get_av_local2(struct IMAGE_INFO *image_info, unsigned char image_mono[IMG_SIZE_V][IMG_SIZE_H], int y);
int get_image_incline(struct AREA_INFO area_info, unsigned char image_mono[IMG_SIZE_V][IMG_SIZE_H]);
void iplimg2dat(IplImage *frameImage, unsigned char image_data0[IMG_SIZE_V][IMG_SIZE_H]);
void dat2iplimg(IplImage *frameImage, unsigned char image_data0[IMG_SIZE_V][IMG_SIZE_H]);

//**************************************************************************
//摜֌W̃[eBeB[
//utils1.cpp
void set_image1(unsigned char image[IMG_SIZE_V][IMG_SIZE_H], int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void separate_image(struct IMAGE_INFO *image_info, unsigned char image[IMG_SIZE_V][IMG_SIZE_H]);
int get_av(struct IMAGE_INFO *image_info, unsigned char image_mono[IMG_SIZE_V][IMG_SIZE_H]);
void mono2color(unsigned char image_mono[IMG_SIZE_V][IMG_SIZE_H], unsigned char image_color[3][IMG_SIZE_V][IMG_SIZE_H]);

void write_area_info(char filename[64], struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]);
void write_imagefile(char filename[64], unsigned char image[3][IMG_SIZE_V][IMG_SIZE_H]);
void delete_noise(unsigned char image[IMG_SIZE_V][IMG_SIZE_H]);

//**************************************************************************
//get_image_info.cpp
void get_image_info(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX],
					int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void get_colored_image(struct IMAGE_INFO *image_info, 
				   unsigned char image[3][IMG_SIZE_V][IMG_SIZE_H], int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void integrate_areanum(struct IMAGE_INFO *image_info, int changed_color, int org_color, int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);

//**************************************************************************
//get_area_info.cpp
void get_area_info_init(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]);
int get_area_info_areanum(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void get_area_info_cog(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void get_area_info_box(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void get_area_info_center(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void get_area_info(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void get_large_area(struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H], unsigned char image[IMG_SIZE_V][IMG_SIZE_H], int pix_num);

//**************************************************************************
/*get_shape_info.cpp*/
void decide_area_shape(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX]
				   ,int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);
void change_image_color(struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX],
				   unsigned char image[3][IMG_SIZE_V][IMG_SIZE_H], int image_att[2][IMG_SIZE_V][IMG_SIZE_H]);

//**************************************************************************
//get_shape_info.cpp
void decide_area_shape1(struct AREA_INFO *area_info, unsigned char image[IMG_SIZE_V][IMG_SIZE_H]
						, int box_i[2][2], int cog[2]);

//**************************************************************************
//edge_test.cpp
int edge_X(char read_fname[256], char write_fname[256]);

//**************************************************************************
//corn_send_inf.cpp
void corn_send_inf(void);
