//---------------------------------------------------------
// Tv      : GbWo
// File Name : edge.cpp
// Library   : OpenCV for MS-Windows 1.0
//---------------------------------------------------------

#include <stdio.h>
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

#define SOBEL_X_APERTURE_SIZE	3	//	SobelIy[^̃TCY (t@XQ)
#define SOBEL_Y_APERTURE_SIZE	3	//	SobelIy[^̃TCY (t@XQ)
#define LAPLACIAN_APERTURE_SIZE	3	//	LaplacianIy[^̃TCY (t@XQ)

//	cvConvertScaleAbsp萔
#define SCALE	1	//	ScaleAbsW
#define	SHIFT	0	//	XP[O͔z̗vfɉl

#include "h11c.h"

//wɃGbWoA\[xIy[^gp
int edge_X(char file_name[256], char out_file[256])
{

	//	摜ǂݍ
    IplImage *sourceImage = cvLoadImage( file_name, CV_LOAD_IMAGE_ANYDEPTH | CV_LOAD_IMAGE_ANYCOLOR );

	if ( sourceImage == NULL ) {
		//	摜Ȃꍇ
		printf( "摜܂\n" );
		return -1;
	}
	
	//	摜𐶐
	IplImage *grayImage = cvCreateImage( cvGetSize( sourceImage ), IPL_DEPTH_8U, 1 );		//	O[XP[摜pIplImage
	IplImage *sobelXImage16 = cvCreateImage( cvGetSize( sourceImage ), IPL_DEPTH_16S, 1 );	//	XSobelIy[^ŏ摜(16bit)pIplImage
	IplImage *sobelXImage8 = cvCreateImage( cvGetSize( sourceImage ), IPL_DEPTH_8U, 1 );	//	XSobelIy[^ŏ摜(8bit)pIplImage
	
	//	BGRO[XP[ɕϊ
	cvCvtColor( sourceImage, grayImage, CV_BGR2GRAY );

	//	XSobelIy[^
	cvSobel( grayImage, sobelXImage16, 1, 0, SOBEL_X_APERTURE_SIZE );

	//	16rbg̕f[^8rbg̕Ȃf[^ɕϊ
	cvConvertScaleAbs( sobelXImage16, sobelXImage8, SCALE, SHIFT );
	
	//	摜ۑ
	cvSaveImage( out_file, sobelXImage8 );
	 
	// 
	cvReleaseImage( &grayImage);
	cvReleaseImage( &sobelXImage16 );
	cvReleaseImage( &sobelXImage8 );
	
	return 0;
}
