#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#include "h11c.h"

void fio_read_color_file(char filename[256], float obj_RGB[2][16][3], int data_num[2]);

//mode		:ǂݎ胂[h@OFS@PFJ[̂݁@QFNGXgt@Ĉ
void fio_read_recog_plm(struct RECOG_PLM *recog_plm, char fname_color[256], char fname_req[256], int mode)
{
int		i, j;
float	a;

int		field_num, left_right;
char	buff[32][64];
char	work[64];

FILE	*fp;
errno_t err;


	//FΏۂ́iԃR[jF`t@Cǎ
	if(mode == 0 || mode == 1)
	{
		fio_read_color_file(fname_color, recog_plm->obj_RGB, recog_plm->obj_RGB_num);
		//FxNg𐳋K

		for(j = 0; j < 2; j++)
		{
			for(i = 0; i < recog_plm->obj_RGB_num[j]; i++)
			{
				a = sqrt(recog_plm->obj_RGB[j][i][0]*recog_plm->obj_RGB[j][i][0] +
					recog_plm->obj_RGB[j][i][1]*recog_plm->obj_RGB[j][i][1] +	recog_plm->obj_RGB[j][i][2]*recog_plm->obj_RGB[j][i][2]);
				recog_plm->obj_RGB[j][i][0] = (float)recog_plm->obj_RGB[j][i][0] / a;//R
				recog_plm->obj_RGB[j][i][1] = (float)recog_plm->obj_RGB[j][i][1] / a;//G
				recog_plm->obj_RGB[j][i][2] = (float)recog_plm->obj_RGB[j][i][2] / a;//B
			}
		}
	}

	//NGXgt@CiFp[^jǎ
	if(mode == 0 || mode == 2)
	{
		/*
	recog_plm->color_th = 0.10;
	recog_plm->min_dist = 300.0;
	recog_plm->max_dist = 8000.0;

	recog_plm->min_pixnum = 4 * 8;
	recog_plm->max_pixnum = 100 * 200;

	recog_plm->left_cam_id = 0;*/

		if ((err = fopen_s(&fp, fname_req , "rt")) != 0)
		{
			printf("G[I(fio_read_recog_plm)NGXgt@CJ܂łB\n");
			return;
		}

		while (fgets(work, 64, fp) != NULL)
		{
			field_num = devide_into_field(work, ",", buff);
			if(field_num == 2)
			{
				if(strcmp(buff[0], "color_th") == 0) recog_plm->color_th = atof(buff[1]);
				if(strcmp(buff[0], "min_dist") == 0) recog_plm->min_dist = atof(buff[1]);
				if(strcmp(buff[0], "max_dist") == 0) recog_plm->max_dist = atof(buff[1]);
				if(strcmp(buff[0], "min_pixnum") == 0) recog_plm->min_pixnum = atoi(buff[1]);
				if(strcmp(buff[0], "max_pixnum") == 0) recog_plm->max_pixnum = atoi(buff[1]);
				if(strcmp(buff[0], "left_cam_id") == 0) recog_plm->left_cam_id = atoi(buff[1]);
			}
		}
		fclose(fp);
	}


}

//J[摜QlŎoF̂qfaxNgt@Cǂݎ
//Ԓl	Ff[^
//filename	:t@C
//obj_RGB	:FxNgf[^
void fio_read_color_file(char filename[256], float obj_RGB[2][16][3], int data_num[2])
{
int		i, field_num, left_right;
char	buff[32][64];
char	work[64];

FILE	*fp;
errno_t err;

	if ((err = fopen_s(&fp, filename , "rt")) != 0)
	{
		printf("G[I(fio_read_color_file)J[t@CJ܂łB\n");
		return;
	}

	data_num[0] = 0;
	data_num[1] = 0;
	while (fgets(work, 64, fp) != NULL)
	{
		field_num = devide_into_field(work, ",", buff);
		if(field_num == 4)
		{
			left_right = atoi(buff[0]);//J͂OAE͂P
			obj_RGB[left_right][ data_num[left_right] ][0] = atof(buff[1]);
			obj_RGB[left_right][ data_num[left_right] ][1] = atof(buff[2]);
			obj_RGB[left_right][ data_num[left_right] ][2] = atof(buff[3]);
			data_num[left_right]++;

			if(data_num[left_right] > 15)
			{
				printf("G[I(fio_read_color_file)@J[t@C̍sPU𒴂Ă܂B\n");
				printf("PUsȍ~͓ǂݍ܂܂łB\n");
				break;
			}
		}
	}
	fclose(fp);
}

/**********************************************************/
/**delimiterŎwꂽLN^[ŃC𕪊   **/
/**F  1,  2,  3,  :abcde                              **/
/**  delimiter = ":" ̎@                              **/
/**  fields[0][] = "  1,  2,  3"                         **/
/**  fields[1][] = "abcde"                               **/
/**********************************************************/
int devide_into_field(char line[1024], char delimiter[16], char fields[32][64])
{
int     i,j,l,m,del_num,length;
int     flg;

	length = (int)strlen(line);
	del_num = (int)strlen(delimiter);
	l = 0;
	m = 0;
	for(i = 0; i < length; i++)
	{
	  fields[l][m] = line[i];
	  flg = 0;
	  for(j = 0; j < del_num; j++)
	  {
	  if((line[i] == delimiter[j] || i == length - 1) && flg == 0)
	    {
	      if(i != length - 1) fields[l][m] = 0;
	      else                fields[l][m + 1] = 0;
	      /*printf("%s\n",fields + l);*/
	      l++;
		  if(l > 32)
		  {
			  printf("G[Iz錾z܂idevide_into_fieldj\n");
			  exit(0);
		  }
	      m = -1;
	      flg = 1;
	    }
	  }
	  m++;
	}
return(l);
}
