#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "h11c.h"

/************************************************************************/
//̈ԍ̃C[Wϐ̂OԃCAɃmNC[W
//(Qlς)Zbg
//̈ԍ|Pŏ
/************************************************************************/
void set_image1(unsigned char image[IMG_SIZE_V][IMG_SIZE_H], int image_att[2][IMG_SIZE_V][IMG_SIZE_H])
{
int		x, y;
char	work_c;

	for(y = 0; y < IMG_SIZE_V; y++)
    {
	   for(x = 0; x < IMG_SIZE_H; x++)
	   {
		   image_att[0][y][x] = (int)image[y][x];
		   image_att[1][y][x] = -1;
	   }
   }
}

/************************************************************************/
//Ql
/************************************************************************/
void separate_image(struct IMAGE_INFO *image_info, unsigned char image[IMG_SIZE_V][IMG_SIZE_H])
{
int		x, y;

	for(y = 0; y < IMG_SIZE_V; y++)
    {
	   for(x = 0; x < IMG_SIZE_H; x++)
	   {
			if(y < image_info->start_y || y > image_info->end_y)
			{
				image[y][x] = 255;
			}
			else
			{
				if(image[y][x] > image_info->level[3])
				{
					image[y][x] = 255;
				}
				else
				{
					image[y][x] = 0;
				}
			}
	   }
	}
}

/************************************************************************/
//mCY
//אڂWsNZ̒ɍiOjRȏȂ΁Ȁꏊ𔒂ɔ]
/************************************************************************/
void delete_noise(unsigned char image[IMG_SIZE_V][IMG_SIZE_H])
{
int		x, y, xx, yy, flg1;
unsigned char image_tmp[IMG_SIZE_V][IMG_SIZE_H];

	//[NzɃIWiC[WRs[
	for(y = 0; y < IMG_SIZE_V; y++)
	{
		for(x = 0; x < IMG_SIZE_H; x++)
		{
			image_tmp[y][x] = image[y][x];
		}
	}

	//C
	for(y = 1; y < IMG_SIZE_V - 1; y++)
	{
		for(x = 1; x < IMG_SIZE_H - 1; x++)
		{
			flg1 = 0;
			//ΏۂɂĂsNZ̗אڃsNZ̃eXgiGAԍj
			for(yy = y - 1; yy <= y + 1; yy++)
			{
				for(xx = x - 1; xx <= x + 1; xx++)
				{
					if(xx != x || yy != y)
					{
						if(image[yy][xx] == image[y][x])
						{
							flg1++;
						}
					}
				}
			}

			if(flg1 < 3)
			{
				if(image_tmp[y][x] > 0)
				{
					image_tmp[y][x] = 0;
				}
				else
				{
					image_tmp[y][x] = 254;
				}
			}
		}
	}

	//IWizɃ[NC[WRs[
	for(y = 0; y < IMG_SIZE_V; y++)
	{
		for(x = 0; x < IMG_SIZE_H; x++)
		{
			image[y][x] = image_tmp[y][x];
		}
	}

}

/************************************************************************/
// level[0]: 
// level[1]: Œ
// level[2]: ō
/************************************************************************/
int get_av(struct IMAGE_INFO *image_info, unsigned char image_mono[IMG_SIZE_V][IMG_SIZE_H])
{
int		x, y;
long	ii;

	ii = 0;
	image_info->level[1] = 255;
	image_info->level[2] = 0;
	for(y = image_info->start_y; y < image_info->end_y; y++)
    {
	   for(x = 0; x < IMG_SIZE_H; x++)
	   {
		   ii = ii + image_mono[y][x];
		   if(image_mono[y][x] < image_info->level[1]) image_info->level[1] = image_mono[y][x];
		   if(image_mono[y][x] > image_info->level[2]) image_info->level[2] = image_mono[y][x];
	   }
	}

	image_info->level[0] = (int)(ii / (IMG_SIZE_H * (image_info->end_y - image_info->start_y)));

	return(0);
}


/************************************************************************/

/************************************************************************/
void write_area_info(char filename[64], struct IMAGE_INFO *image_info, struct AREA_INFO area_info[AREANUM_MAX])
{
int		i, j;

FILE	*fpo;

	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(i = 0; i < image_info->area_num; i++)
	    {
			if(area_info[i].pix_num != 0)
			{
				//dS
				fprintf(fpo, "%4d, %4d,", area_info[i].cog_x, area_info[i].cog_y);
				//anw
				fprintf(fpo, "% 4d, %4d,", area_info[i].box[0][0], area_info[i].box[0][1]);
				fprintf(fpo, "% 4d, %4d", area_info[i].box[1][0], area_info[i].box[1][1]);
				fprintf(fpo, "\n");

				//anwɂĂʒu̍W
				for(j = 0; j < 4; j++)
				{
					fprintf(fpo, "%4d, %4d\n", area_info[i].coo_max[j][0], area_info[i].coo_max[j][1]);
				}

				//Z^[C̎n_AI_̍W
				fprintf(fpo, "%4d, %4d\n", area_info[i].centerline[0][0], area_info[i].centerline[0][1]);
				fprintf(fpo, "%4d, %4d\n", area_info[i].centerline[1][0], area_info[i].centerline[1][1]);
			}
	   }
	   fclose(fpo);
	}
	else
	{
	   printf("G[IGAt@CJ܂łB\n");
	}
	return;
}

/************************************************************************/

/************************************************************************/
void write_imagefile(char filename[64], unsigned char image[3][IMG_SIZE_V][IMG_SIZE_H])
{
int		x,y;

FILE	*fpo;

	if ((fpo = fopen(filename, "wt")) != NULL)
	{
		for(y = 0; y < IMG_SIZE_V; y++)
	    {
		   for(x = 0; x < IMG_SIZE_H; x++)
		   {
			   fprintf(fpo, "%4d,", image[0][y][x]);
			   fprintf(fpo, "%4d,", image[1][y][x]);
			   fprintf(fpo, "%4d\n", image[2][y][x]);
		   }
	   }
	   fclose(fpo);
	}
	else
	{
	   printf("G[IC[Wt@CJ܂łB\n");
	}
	return;
}

/************************************************************************/

/************************************************************************/
void mono2color(unsigned char image_mono[IMG_SIZE_V][IMG_SIZE_H], unsigned char image_color[3][IMG_SIZE_V][IMG_SIZE_H])
{
int		i, x, y;

	for(y = 0; y < IMG_SIZE_V; y++)
    {
	   for(x = 0; x < IMG_SIZE_H; x++)
	   {
		   for(i = 0; i < 3; i++) image_color[i][y][x] = image_mono[y][x];
	   }
   }
}
